

//filename: mainSamp.h

HMODULE hLib301 = NULL;

BOOLEAN SetCon(void); BOOLEAN Init(void); BOOLEAN keyChk(void); BOOLEAN DoInitWithThread(void);

void setMainScreen(void); void showData(BYTE bAvgType); void EndScan(void);

ULONG ThreadFunc(LPVOID pVoid);



#define AVG_VAL 32

BYTE bAvg = AVG_VAL, bAvgCnt = 0, bIndexSub = 0;



// Developer NOTE: 

// Please see "FuncUse.html" documentation at website for information about 

// all function calls and related definitions such as the ones shown below.

#define MULTI_CHAN_CAL_SCAN  3

#define SCAN_USE_DATA_ARRAY 2



UINT puiNumScansRemainingInBuff, puiStatusCode, uiNumScansToReturn, puiNumScansReturned; 

BOOLEAN fWaitInit=TRUE; BOOLEAN fInitSuccess=TRUE;

double dblRate = 600.0;

// Developer NOTE:

// When doing a calibration scan, the buffer must be a size equal to at least the number of

//  channels you want to scan, PLUS the offset channel (used for calibration) since the offset

//  channel is always returned automatically within the scan data array. 



// IMPORTANT: The offset (also referred to as calibration) channel is always the last channel

//  and is referred to as channel 7 even if you only have 4 channels as with the Model 301. With

//  the model 301 it is the fourth channel and with the model 302 it is the eighth channel.

//  All channels are scanned sequentially so the only way to read the offset channel when doing

//  a scan comprised of less than the total channels for the device is to use a calibration type

//  of scan since it will read the last channel regardless of the number of channels you decide

//  to scan. 

// To better explain - if you want to scan only channel zero, but also need the highest possible 

//  accuracy possible by subtracting the offset voltage, you would want to use a calibration 

//  scan setup by passing 1 as the number of channels to scan. When you read the data, the voltages

//  for channel zero will be the first element data in the data array, and the offset voltage will be

//  the second element data which you should then subtract from the channel zero data to get the actual

//  data as referenced to zero volts. Also note that a normal multi-channel scan setup to scan all

//  the channels is no different than a multi-channel-calibration scan setup to scan all but the

//  last channel since with the multi-channel-calibration scan the last channel will be automatically

//  returned anyways.





UINT puiTotalBuffSize = 4056;  // MUST be sized according to number of scans you'll be reading

 

BOOLEAN pfStillScanning = TRUE, fGetAllRequested = FALSE; 

int iDataBuff[512];		// MUST be sized according to number of scans you'll be reading

int* piDataBuff=iDataBuff; 

int iAvgBuff[8];

USHORT usDevID = 0; int iKeyChar = 0; char cUserInputVal = NULL; 

BOOLEAN fRetVal = FALSE,  fStartSuccess = FALSE, fRunning = TRUE;





typedef BOOLEAN (*P_DLL_EX_CONNECT) (USHORT* usDevID);

P_DLL_EX_CONNECT EX_Connect = NULL;



typedef BOOLEAN (*P_DLL_EX_SEND_RATE) (USHORT usDevID, double* dblRate);

P_DLL_EX_SEND_RATE EX_SendRate = NULL;



typedef BOOLEAN (*P_DLL_EX_SET_SCAN_TYPE) (USHORT usDevID, BYTE bScanType);

P_DLL_EX_SET_SCAN_TYPE EX_SetScanType = NULL;



typedef BOOLEAN (*P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS) (USHORT usDevID, BYTE bChanCnt);

P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS EX_SetMultiChanScanChans = NULL;



typedef BOOLEAN (*P_DLL_EX_SET_DATA_LOG_OPTIONS) (USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc);

P_DLL_EX_SET_DATA_LOG_OPTIONS EX_SetDataLogOptions = NULL;



typedef BOOLEAN (*P_DLL_EX_RUN) (USHORT usDevID);

P_DLL_EX_RUN EX_Run = NULL;



typedef BOOLEAN(*P_DLL_EX_CHECK_SCAN_STATUS) (USHORT usDevID, UINT* puiNumScansRemainingInBuff, 

						   BOOLEAN* pfStillScanning, UINT* puiStatusCode);

P_DLL_EX_CHECK_SCAN_STATUS EX_CheckScanStatus = NULL;



typedef BOOLEAN (*P_DLL_EX_GET_SCAN_DATA_DOUBLE_DIGIN)( USHORT usDevID, double* pdblDataBuff, BYTE* pbDiginBuff, UINT uiNumScansToReturn,

		BOOLEAN fGetAllRequested, UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, 

		BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiStatusCode );

P_DLL_EX_GET_SCAN_DATA_DOUBLE_DIGIN EX_GetScanDataDblDigin = NULL;



typedef BOOLEAN (*P_DLL_EX_GET_SCAN_DATA_INT)( USHORT usDevID, int* piDataBuff, UINT uiNumScansToReturn,

		BOOLEAN fGetAllRequested, UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, 

		BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiStatusCode );

P_DLL_EX_GET_SCAN_DATA_INT EX_GetScanDataInt = NULL;



typedef BOOLEAN (*P_DLL_EX_STOP) (USHORT usDevID);

P_DLL_EX_STOP EX_Stop = NULL;



typedef BOOLEAN (*P_DLL_EX_STOP_COMPLETE) (USHORT usDevID);

P_DLL_EX_STOP_COMPLETE EX_StopComplete = NULL;





// This is just stuff to handle the console for writing to particular line locations

HANDLE	hOutCon, hInCon;

COORD	pos, dwCursorPosition;

CONSOLE_CURSOR_INFO	ConsoleCursorInfo;

CONSOLE_SCREEN_BUFFER_INFO lpConsoleScreenBufferInfo;

DWORD	lpNumberOfCharsWritten;

#define gotoxy(x, y) pos.X = x; pos.Y = y - 1;	\

SetConsoleCursorPosition(hOutCon, pos);

#define clrscr() pos.X = 0; pos.Y = 0;		\

FillConsoleOutputCharacter(hOutCon, ' ',	\

80*25, pos, &lpNumberOfCharsWritten);



